use uo;

include "include/client";
include "include/classes";
include "include/itemutil";

function repair_item( character , item , skillid )
     	
	var damaged 	:= Cint( item.maxhp - item.hp );
	var skill 	:= GetSkill( character, skillid );
	var armslore 	:= GetSkill( character, SKILLID_ARMSLORE );
	var diff 	:= Cint( damaged + 20 );

	armslore := Cint( armslore * ClasseBonus( character, CLASSEID_CRAFTER ) );

	//The item should be broken already
	if((item.hp < 1) or (item.hp > item.maxhp ) or (item.quality <= 0.1) or (!item.quality))
		SendSysmessage(character, "The brittle material breaks when you handle it!");
		DestroyTheItem( character, item );
		return;
	endif

	//Check if the item is damaged
	if( item.hp = item.maxhp )
		SendSysmessage( character , "That item is in perfect condition already." );
		return;
	endif
	
	//Check if you have a chance to repair it
	if( armslore >= damaged )
	
		//Check if he repair it
		if( CheckSkill( character, skillid, diff, 0 ) )

			//Check for a special effect
			var chance := Random(100);
			
			//Bad luck, destroyed (and prevent skill gain from macro repair)
			if( chance < 2 )
				SendSysmessage( character, "You fail and destroy the item" );
				DestroyTheItem( character, item );
				return;
			
			//Bad luck, the item get damaged
			elseif( chance < 5 )
				var dmg := Cint(damaged / 8);
				if( dmg < 1 )
					dmg := 1;
				endif
				
				if( dmg >= item.hp )
					SendSysmessage( character, "You fail and destroy the item" );
					DestroyTheItem( character , item );
				else
					SendSysmessage( character , "You fail in your repairing attempt and damage the item!" );
					item.hp := item.hp - dmg;
				endif
				return;
				
			//Good luck, the item's quality improve
			elseif( chance = 99 )
				SendSysmessage( character , "Your chance and skill improved the quality of the item!" );
				item.quality := Cdbl(item.quality + 0.05);
				item.hp := item.maxhp;
				return;
			
			//You repair the item
			else
				var amount := Cint((Random(armslore)+1) / 2 );
				if( amount >= damaged )
					item.hp := item.maxhp;
					SendSysmessage (character, "You repair the item completely.");
				else
					item.hp := item.hp + amount;	
					SendSysmessage (character, "You successfully repair some of the damage");
				endif
				return;
			endif
		
		//You fail to repair it	
		else
			var dmg := Cint(damaged / 2);
			if( dmg < 1 )
				dmg := 1;
			endif
				
			if( dmg >= item.hp )
				SendSysmessage( character, "You fail and destroy the item" );
				DestroyTheItem( character , item );
			else
				SendSysmessage( character , "You fail in your repairing attempt and damage the item!" );
				item.hp := item.hp - dmg;
			endif
			return;
		endif
	
	//You didn't even had a chance to repair it	
	else
		var dmg := Cint(damaged / 4);
		if( dmg < 1 )
			dmg := 1;
		endif
			
		if( dmg >= item.hp )
			SendSysmessage( character, "You fail and destroy the item" );
			DestroyTheItem( character, item );
		else
			SendSysmessage( character, "You fail in your repairing attempt and damage the item!" );
			item.hp := item.hp - dmg;
		endif
		return;
	endif

endfunction